Skip to content

Creates a new contact directory record that does not already exist.

Request

This method will auto-generate an ID and create a new contact directory. If an ID is specified for the contact directory, an error will be thrown.

Security
knox-authorizer
Path
tenantIdstringrequired

The id of the tenant being accessed.

Bodyapplication/jsonrequired

The contact directory that you would like to be saved.

additional_fieldsArray of strings(Additional Fields)

These are additional fields that should be in the directory query, which will be available in the search results

comment_optionsobject(Comment Options)
custom_directory_entry_templatestring(Custom Directory Entry Template)required
custom_search_results_templatestring(Custom Search Results Template)required
custom_sort_fieldsArray of objects, non-emptyrequired
directory_entry_modestring(Directory Entry Mode)
Enum:"custom""do not show""use default"
display_modestring(Display Mode)

The way that the directory should be displayed

Enum:"list""search"
eligibility_criteriaobject(Eligibility Criteria)required

The criteria to use

enable_commentsboolean(Enable Comments)

If set, users are allowed to submit comments in the directory

enable_custom_search_results_templateboolean(Enable Custom Search Results Template)

If set, a custom search results template is displayed

enable_custom_sortingboolean(Enable Custom Sorting)

If true, the directory results will be sorted differently that the query

enable_eligibility_criteriaboolean(Enable Eligibility Criteria)

If set, only certain people can access this directory

enable_messagingboolean(Enable Messaging)

When true, users are able to contact other users through the directory

enable_query_expression_filterboolean(Enable Query Expression Filter)

If set to true, an expression can be used to further filter the query

enable_query_filterboolean(Enable Query Filter)

If set to true, the directory can display a subset of records based on the provided filter. If false, the default filter is used

idstring(ID)^[\w|-]+$required

The unique, string identifier of this contact directory

is_activeboolean(Is Active)

Whether or not this directory is active

is_publicboolean(Is Public)

If true, this is a public directory that can be accessed without security

namestring(Name)required

The name of the contact directory

page_sizenumber, (float), [ 1 .. 50 ](Page Size)

The page size, used for server side page and to combat scraping attacks

query_filter_expressionstring(Query Filter Expression)required

The expression to use to filter the directory

query_filter_rulesobject(Query Filter Rules)
radius_search_optionsobject(Radius Search Options)required
refresh_periodnumber, (float), >= 5(Refresh Period)

The period of time (in minutes) after which the directory should refresh it self

searchable_fieldsArray of objects, non-emptyrequired

The fields in the directory that are displayed as search criteria

sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

curl -i -X POST \
  'https://docs.api.rhythmsoftware.com/_mock/apis/rolodex/rolodex-v1/contactDirectories/{tenantId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "additional_fields": [
      "string"
    ],
    "comment_options": {
      "comments_header_text": "string",
      "comments_instructions": "string",
      "comments_placeholder_text": "string",
      "enable_ratings": true,
      "hide_submitter_name": true,
      "leave_comment_button_text": "string",
      "max_rating": 1,
      "no_comments_text": "string",
      "rating_label": "string",
      "save_comment_button": "string"
    },
    "custom_directory_entry_template": "string",
    "custom_search_results_template": "string",
    "custom_sort_fields": [
      {
        "descending": true,
        "name": "string"
      }
    ],
    "directory_entry_mode": "custom",
    "display_mode": "list",
    "eligibility_criteria": {
      "advanced_rule_error_message": "string",
      "advanced_rules": {},
      "age_restrictions": {
        "maximum_age": 0.1,
        "minimum_age": 0.1
      },
      "award_options": {
        "award_ids": [
          "string"
        ],
        "award_type_ids": [
          "string"
        ],
        "logic_operator": "and"
      },
      "award_recipients": true,
      "by_location": true,
      "certificants": true,
      "certification_options": {
        "logic_operator": "and",
        "program_ids": [
          "string"
        ]
      },
      "committee_member_options": {
        "committee_ids": [
          "string"
        ],
        "committee_position_ids": [
          "string"
        ],
        "committee_type_ids": [
          "string"
        ],
        "logic_operator": "and"
      },
      "committee_members": true,
      "custom_logic_options": {
        "lambda_function_id": "string"
      },
      "customer_type": "contact",
      "donor_options": {
        "donor_club_ids": [
          "string"
        ],
        "logic_operator": "and"
      },
      "donors": true,
      "enable_advanced_rules": true,
      "enable_age_restrictions": true,
      "enable_custom_logic": true,
      "enable_entitlement_restrictions": true,
      "enable_expression": true,
      "enable_organization_restrictions": true,
      "enable_status_restriction": true,
      "entitlement_restrictions": [
        {
          "quantity": 0.1,
          "type_id": "string"
        }
      ],
      "event_registration_options": {
        "event_ids": [
          "string"
        ],
        "logic_operator": "and",
        "registration_category_ids": [
          "string"
        ]
      },
      "event_registrations": true,
      "expression": "string",
      "expression_error_message": "string",
      "location": {
        "countries": [
          "string"
        ],
        "negate_logic": true
      },
      "logic_operator": "and",
      "member_options": {
        "chapter_member_options": {
          "chapter_ids": [
            "string"
          ],
          "chapter_type_ids": [
            "string"
          ],
          "logic_operator": "and"
        },
        "chapter_members": true,
        "member_package_ids": [
          "string"
        ],
        "member_status_reason_ids": [
          "string"
        ],
        "member_statuses": [
          "active"
        ],
        "member_type_ids": [
          "string"
        ],
        "section_member_options": {
          "logic_operator": "and",
          "section_ids": [
            "string"
          ],
          "section_type_ids": [
            "string"
          ]
        },
        "section_members": true
      },
      "members": true,
      "non_members": true,
      "organization_restrictions": {
        "contact_role_ids": [
          "string"
        ],
        "organization_type_ids": [
          "string"
        ]
      },
      "status_restrictions": [
        "string"
      ],
      "use_organization_for_eligibility": true
    },
    "enable_comments": true,
    "enable_custom_search_results_template": true,
    "enable_custom_sorting": true,
    "enable_eligibility_criteria": true,
    "enable_messaging": true,
    "enable_query_expression_filter": true,
    "enable_query_filter": true,
    "enable_radius_search": true,
    "id": "string",
    "is_active": true,
    "is_public": true,
    "name": "string",
    "page_size": 1,
    "query_filter_expression": "string",
    "query_filter_rules": {},
    "radius_search_options": {
      "postal_code_field": "string",
      "radius_options": [
        0.1
      ]
    },
    "refresh_period": 5,
    "searchable_fields": [
      {
        "group_name": "string",
        "label": "string",
        "name": "string"
      }
    ],
    "sys_bulk_load_at": "string",
    "sys_bulk_load_id": "string",
    "sys_bulk_load_pk": "string",
    "sys_bulk_load_record_no": 0.1,
    "sys_bulk_load_source_file": "string",
    "sys_calculated_field_error": "string",
    "sys_calculated_field_errors": [
      {
        "error": "string",
        "field": "string"
      }
    ],
    "sys_configuration_snapshot_id": "string",
    "sys_created_at": "2019-08-24T14:15:22Z",
    "sys_created_by_id": "string",
    "sys_deleted_by_id": "string",
    "sys_directive": "string",
    "sys_external_id": "string",
    "sys_has_files_in_s3": true,
    "sys_last_bulk_data_operation_id": "string",
    "sys_last_bulk_data_operation_sys_version": "string",
    "sys_last_modified_at": "2019-08-24T14:15:22Z",
    "sys_last_modified_by_id": "string",
    "sys_last_security_context": {},
    "sys_locked": true,
    "sys_snapshot_base_version": 0.1,
    "sys_version": 0.1
  }'

Responses

The contact directory was saved successfully.

Headers
Access-Control-Allow-Headersstring
Access-Control-Allow-Methodsstring
Access-Control-Allow-Originstring
Bodyapplication/json
additional_fieldsArray of strings(Additional Fields)

These are additional fields that should be in the directory query, which will be available in the search results

comment_optionsobject(Comment Options)
custom_directory_entry_templatestring(Custom Directory Entry Template)required
custom_search_results_templatestring(Custom Search Results Template)required
custom_sort_fieldsArray of objects, non-emptyrequired
directory_entry_modestring(Directory Entry Mode)
Enum:"custom""do not show""use default"
display_modestring(Display Mode)

The way that the directory should be displayed

Enum:"list""search"
eligibility_criteriaobject(Eligibility Criteria)required

The criteria to use

enable_commentsboolean(Enable Comments)

If set, users are allowed to submit comments in the directory

enable_custom_search_results_templateboolean(Enable Custom Search Results Template)

If set, a custom search results template is displayed

enable_custom_sortingboolean(Enable Custom Sorting)

If true, the directory results will be sorted differently that the query

enable_eligibility_criteriaboolean(Enable Eligibility Criteria)

If set, only certain people can access this directory

enable_messagingboolean(Enable Messaging)

When true, users are able to contact other users through the directory

enable_query_expression_filterboolean(Enable Query Expression Filter)

If set to true, an expression can be used to further filter the query

enable_query_filterboolean(Enable Query Filter)

If set to true, the directory can display a subset of records based on the provided filter. If false, the default filter is used

idstring(ID)^[\w|-]+$required

The unique, string identifier of this contact directory

is_activeboolean(Is Active)

Whether or not this directory is active

is_publicboolean(Is Public)

If true, this is a public directory that can be accessed without security

namestring(Name)required

The name of the contact directory

page_sizenumber, (float), [ 1 .. 50 ](Page Size)

The page size, used for server side page and to combat scraping attacks

query_filter_expressionstring(Query Filter Expression)required

The expression to use to filter the directory

query_filter_rulesobject(Query Filter Rules)
radius_search_optionsobject(Radius Search Options)required
refresh_periodnumber, (float), >= 5(Refresh Period)

The period of time (in minutes) after which the directory should refresh it self

searchable_fieldsArray of objects, non-emptyrequired

The fields in the directory that are displayed as search criteria

sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

Response
{ "additional_fields": [ "string" ], "comment_options": { "comments_header_text": "string", "comments_instructions": "string", "comments_placeholder_text": "string", "enable_ratings": true, "hide_submitter_name": true, "leave_comment_button_text": "string", "max_rating": 1, "no_comments_text": "string", "rating_label": "string", "save_comment_button": "string" }, "custom_directory_entry_template": "string", "custom_search_results_template": "string", "custom_sort_fields": [ { … } ], "directory_entry_mode": "custom", "display_mode": "list", "eligibility_criteria": { "advanced_rule_error_message": "string", "advanced_rules": {}, "age_restrictions": { … }, "award_options": { … }, "award_recipients": true, "by_location": true, "certificants": true, "certification_options": { … }, "committee_member_options": { … }, "committee_members": true, "custom_logic_options": { … }, "customer_type": "contact", "donor_options": { … }, "donors": true, "enable_advanced_rules": true, "enable_age_restrictions": true, "enable_custom_logic": true, "enable_entitlement_restrictions": true, "enable_expression": true, "enable_organization_restrictions": true, "enable_status_restriction": true, "entitlement_restrictions": [ … ], "event_registration_options": { … }, "event_registrations": true, "expression": "string", "expression_error_message": "string", "location": { … }, "logic_operator": "and", "member_options": { … }, "members": true, "non_members": true, "organization_restrictions": { … }, "status_restrictions": [ … ], "use_organization_for_eligibility": true }, "enable_comments": true, "enable_custom_search_results_template": true, "enable_custom_sorting": true, "enable_eligibility_criteria": true, "enable_messaging": true, "enable_query_expression_filter": true, "enable_query_filter": true, "enable_radius_search": true, "id": "string", "is_active": true, "is_public": true, "name": "string", "page_size": 1, "query_filter_expression": "string", "query_filter_rules": {}, "radius_search_options": { "postal_code_field": "string", "radius_options": [ … ] }, "refresh_period": 5, "searchable_fields": [ { … } ], "sys_bulk_load_at": "string", "sys_bulk_load_id": "string", "sys_bulk_load_pk": "string", "sys_bulk_load_record_no": 0.1, "sys_bulk_load_source_file": "string", "sys_calculated_field_error": "string", "sys_calculated_field_errors": [ { … } ], "sys_configuration_snapshot_id": "string", "sys_created_at": "2019-08-24T14:15:22Z", "sys_created_by_id": "string", "sys_deleted_by_id": "string", "sys_directive": "string", "sys_external_id": "string", "sys_has_files_in_s3": true, "sys_last_bulk_data_operation_id": "string", "sys_last_bulk_data_operation_sys_version": "string", "sys_last_modified_at": "2019-08-24T14:15:22Z", "sys_last_modified_by_id": "string", "sys_last_security_context": {}, "sys_locked": true, "sys_snapshot_base_version": 0.1, "sys_version": 0.1 }